pnet('closeall')
vrata = pnet('tcpsocket',2013);
povezava = pnet(vrata,'tcplisten');
disp('sprejemnik se je povezal')
sporocilo = 'OPRAVLJANJE IZPITA PRI PREDMETU GRADNIKI SISTEMOV VODENJA';

%% kodiranje sporocila: Huffman
sporocilo = huff_code(sporocilo);
%% delitev sporocila na segmente po 8 bytov
n_seg = ceil(length(sporocilo)/64);
pak = cell(1,n_seg);
for k = 1 : n_seg
    if k == n_seg
        pak{k}.data = sporocilo((k-1)*64+1:end);
    else
        pak{k}.data = sporocilo((k-1)*64+1:k*64);
    end
end
%% dodajanje glave segmentom
for k = 1:n_seg
    pak{k}.id = 1;
    pak{k}.tip = 1;
    pak{k}.prejemnik = 1;
    pak{k}.npak = n_seg;
    pak{k}.kpak = k;
    pak{k}.dolz = length(pak{k}.data);
end
%% pretvorba segmenta v binarni zapis
for k = 1 : n_seg
    data_bin = dec2bin(pak{k}.id,16);
    data_bin = [data_bin,dec2bin(pak{k}.tip,8)];
    data_bin = [data_bin,dec2bin(pak{k}.prejemnik,8)];
    data_bin = [data_bin,dec2bin(pak{k}.npak,8)];
    data_bin = [data_bin,dec2bin(pak{k}.kpak,8)];
    data_bin = [data_bin,dec2bin(pak{k}.dolz,8)];
    if pak{k}.dolz == 64
        data_bin = [data_bin,pak{k}.data];
    else
        data_bin = [data_bin,pak{k}.data,num2str(zeros(1,64-pak{k}.dolz))];
        data_bin = data_bin(~ismember(data_bin,' '));
    end
%% sestava paketov, kodiranje po Hammingu 8,4 in pretvorba v uint8
    n_pak = ceil(length(data_bin)/4);
    for l = 1 : n_pak
        if l == n_pak
            l_pak = length(data_bin((l-1)*4+1:end));
            data_bin_par = uint8(hamm_code([data_bin((l-1)*4+1:end),num2str(zeros(1,4-l_pak))]));
        else
            data_bin_par = uint8(hamm_code(data_bin((l-1)*4+1:l*4)));
        end
%% oddajanje paketov
%         disp('oddajam ...')
        pnet(povezava,'write',data_bin_par,'intel');
%         pause(0.01)
    end
end
pnet('closeall')
disp('oddaja koncana')
